/*
 * bitmap.c
 *
 * ӥåȥޥåɽΥץ
 *
 */
#include <GL/glut.h>

/*
 * "" Υӥåȥޥåץǡ  24 x 24
 */
GLubyte zero_bitmap[72] = {
    0x00, 0x30, 0x00, 0x00, 0x30, 0x60, 0x00, 0x31, 0xf0, 0x00, 0x30, 0x30,
    0x00, 0x30, 0x30, 0x00, 0x30, 0x30, 0x0f, 0xff, 0xf0, 0xe0, 0x00, 0x00,
    0x18, 0x00, 0x0e, 0x06, 0x7e, 0x7f, 0x01, 0x81, 0xe0, 0x00, 0xc3, 0x00,
    0x00, 0x74, 0x00, 0x0f, 0xb9, 0xf0, 0x00, 0x18, 0x00, 0x00, 0x18, 0x00,
    0x67, 0x99, 0xe8, 0x60, 0x18, 0x04, 0x30, 0x18, 0x06, 0x3f, 0xff, 0xff,
    0x10, 0x18, 0x06, 0x10, 0x18, 0x00, 0x0f, 0xff, 0xf8, 0x00, 0x00, 0x30 };

void
initialize(void)
{
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    glClearColor(1.0f, 1.0f, 1.0f, 0.0f);
}

void
keyboard(unsigned char key, int x, int y)
{
    const unsigned char ESCAPE_KEY = 0x1B;
    if (key == ESCAPE_KEY) exit(0);
}

void
reshape(int width, int height)
{
    glViewport(0, 0, width, height);
    glLoadIdentity();
    glOrtho(0.0, (GLdouble)width, 0.0, (GLdouble)height, 0.0, 1.0);
}

void
display(void)
{
    glClear(GL_COLOR_BUFFER_BIT);
    glColor3f(0.0f, 0.0f, 0.0f);

    /* ֤ */
    glRasterPos2f(2.0, 2.0);

    /* ӥåȥޥåץǡ */
    glBitmap(24, 24, 0.0, 0.0, 0.0, 0.0, zero_bitmap);
    glFlush();
}

int
main(int argc, char* argv[])
{
    glutInitDisplayMode( GLUT_SINGLE | GLUT_RGB );
    glutInitWindowPosition( 100, 100 );
    glutInitWindowSize( 300, 300 );
    glutCreateWindow( argv[0] );

    glutReshapeFunc( reshape );
    glutDisplayFunc( display );
    glutKeyboardFunc( keyboard );

    initialize();
    glutMainLoop();
    return 0;
}
