/*
 * font-bitmap.c GLUTΥӥåȥޥåץեȤȤץ
 */
#include <GL/glut.h>
#include "font.h"

void
initialize(void)
{
    glClearColor(1.0f, 1.0f, 1.0f, 0.0f);
}

void
drawBitmapString(GLfloat x, GLfloat y, void *font, char *string)
{
    /* ߤΥ饹ݥ¸ */
    glPushAttrib(GL_CURRENT_BIT);
    
    glRasterPos2f(x, y);

    /* ӥåȥޥåʸ */
    while (*string) 
	glutBitmapCharacter(font, *string++);

    /* ¸饹ݥΥ */
    glPopAttrib();
}

void
display(void)
{
    glClear(GL_COLOR_BUFFER_BIT);
    glColor3f(0.0f, 0.0f, 0.0f);
    
    drawBitmapString(5.0f, 270.0f,
      GLUT_BITMAP_8_BY_13, 
      "Fixed-8x13 0123456 absdefg ABCDEFG");
    
    drawBitmapString(5.0f, 250.0f,
      GLUT_BITMAP_9_BY_15,
      "Fixed-9x15 0123456 absdefg ABCDEFG");
    
    drawBitmapString(5.0f, 200.0f,
      GLUT_BITMAP_TIMES_ROMAN_10,
      "Times-Roman-10 0123456 absdefg ABCDEFG");
    
    drawBitmapString(5.0f, 180.0f,
      GLUT_BITMAP_TIMES_ROMAN_24, 
      "Times-Roman-24 0123456 absdefg ABCDEFG"); 

    drawBitmapString(5.0f, 130.0f,
      GLUT_BITMAP_HELVETICA_10, 
      "Helvetica-10 0123456 absdefg ABCDEFG");
    
    drawBitmapString(5.0f, 110.0f,
      GLUT_BITMAP_HELVETICA_12, 
      "Helvetica-12 0123456 absdefg ABCDEFG");
    
    drawBitmapString(5.0f,  90.0f,
      GLUT_BITMAP_HELVETICA_18, 
      "Helvetica-18 0123456 absdefg ABCDEFG");
    
    drawBitmapString(70.0f, 25.0f,
      GLUT_BITMAP_HELVETICA_12,
      "OpenGL(TM) is a registered trademark");
    drawBitmapString(70.0f,  5.0f,
      GLUT_BITMAP_HELVETICA_12, 
      "of Silicon Graphics, Inc.");

    glFlush();
}

void
keyboard(unsigned char key, int x, int y)
{
    const unsigned char ESCAPE_KEY = 0x1B;
    if (key == ESCAPE_KEY) exit(0);
}

void
reshape(int width, int height)
{
    glViewport(0, 0, width, height);
    glLoadIdentity();
    glOrtho(0.0, (GLdouble)width, 0.0, (GLdouble)height, 0.0, 1.0);
}

int
main(int argc, char* argv[])
{
    glutInit( &argc, argv );
    glutInitDisplayMode( GLUT_SINGLE | GLUT_RGB );
    glutInitWindowPosition( 100, 100 );
    glutInitWindowSize( 500, 300 );
    glutCreateWindow( argv[0] );

    glutReshapeFunc( reshape );
    glutDisplayFunc( display );
    glutKeyboardFunc( keyboard );

    initialize();
    glutMainLoop();
    return 0;
}
