/*
** twoside.c - ξ̥饤ƥ
*/

#include <GL/glut.h>
#include "laconia.h"

void
initialize(void)
{
  glClearColor( 0.0f, 0.0f, 0.0f, 1.0f );

  glMatrixMode( GL_MODELVIEW );
  glLoadIdentity();
  gluLookAt( 0.0, 50.0, 100.0,
             0.0,  0.0,   0.0,
             0.0,  1.0,   0.0 );

  glEnable( GL_DEPTH_TEST );
  /* ХåեݥꥴࡼХ */
/*
  glEnable( GL_CULL_FACE );
*/

  glEnable( GL_LIGHTING );
  glEnable( GL_LIGHT0 );
  glEnable( GL_NORMALIZE );

  /* ξ̥饤ƥ󥰤ͭˤ */
  glLightModelf( GL_LIGHT_MODEL_TWO_SIDE, 1.0 );
}

void
display(void)
{
  static GLfloat front[] = { 0.0, 1.0, 0.0, 1.0 };
  static GLfloat back[] = { 0.0, 0.0, 1.0, 1.0 };
  static GLfloat lightPos[] = { 0.0, 0.0, 0.0, 1.0 };
  static float lightX = -51.0;
  static float angle = -1.0;

  lightX += 1.0;
  if( lightX>=51.0 ) lightX -= 101.0;
  angle += 1.0;
  if( angle>=360.0 ) angle -= 360.0;

  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

  glPushMatrix();
  glTranslatef( lightX, 30.0, 0.0 );
  glDisable( GL_LIGHTING );
  lacSphere( 1.0, 's' );
  glEnable( GL_LIGHTING );
  glLightfv( GL_LIGHT0, GL_POSITION, lightPos );
  glPopMatrix();

  glPushMatrix();
  glRotatef( -angle, 1.0, 0.0, 0.0 );

  /* ݥꥴɽ΢̡ο */
  glMaterialfv( GL_FRONT, GL_AMBIENT_AND_DIFFUSE, front );
  glMaterialfv( GL_BACK, GL_AMBIENT_AND_DIFFUSE, back );

  lacMountain( 20.0 );
  glPopMatrix();

  glutSwapBuffers();
}

void
keyboard( unsigned char c, int x, int y )
{
  if( c==27 ) exit( 0 );
}

void
reshape( int w, int h )
{
  glViewport( 0, 0, w, h );

  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  gluPerspective( 45.0, 1.0, 1.0, 1000.0 );
  glMatrixMode( GL_MODELVIEW );
}

void
animate(void)
{
  glutPostRedisplay();
}

int
main( int argc, char *argv[] )
{
  glutInit( &argc, argv );

  glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );

  glutInitWindowPosition( 100, 100 );
  glutInitWindowSize( 500, 400 );
  glutCreateWindow( argv[0] );

  glutDisplayFunc( display );
  glutKeyboardFunc( keyboard );
  glutReshapeFunc( reshape );
  glutIdleFunc( animate );

  initialize();
  glutMainLoop();
  return 0;
}
